package com.mt.wms.basic.params;

import com.mt.wms.core.base.BaseParam;
import com.mt.wms.core.validator.groups.UpdateGroup;
import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import lombok.Data;
import lombok.EqualsAndHashCode;
import lombok.experimental.Accessors;

import javax.validation.constraints.NotNull;

/**
 * @Author: liguanghao
 * @Date: 2021/11/9 12:07
 * @Version 1.0
 */
@Data
@EqualsAndHashCode(callSuper = false)
@Accessors(chain = true)
@ApiModel(value = "工业炉参数对象", description = "用于新增和更新工业炉信息")
public class KilnInfoParam extends BaseParam {

    private static final long serialVersionUID = 1L;
    /**
     * 主键，自增
     */
    @ApiModelProperty(value = "主键，更新时需要填写",required = false, example = "1")
    @NotNull(message = "xxID不能为空", groups = {UpdateGroup.class})
    private Long id;

    /**
     * 编码
     */
    @ApiModelProperty(value = "编码",  example = "1")
    @NotNull(message = "编码不能为空")
    private String code;

    /**
     * 名称
     */
    @ApiModelProperty(value = "名称",  example = "1")
    @NotNull(message = "名称不能为空")
    private String kilnName;

    /**
     * 别名
     */
    @ApiModelProperty(value = "缩写(别名)",  example = "1")
    @NotNull(message = "别名不能为空")
    private String kilnAlias;
    /**
     * 设备类型，存储数据字典编码，修改为1：加工炉，2：回火炉，3：氮化炉，4：清洗炉
     */
    @ApiModelProperty(value = "设备类型，存储数据字典编码，修改为1：加工炉，2：回火炉，3：氮化炉，4：清洗炉",  example = "1")
    @NotNull(message = "设备类型不能为空")
    private Integer type;


    /**
     * 英文名
     */
    @ApiModelProperty(value = "英文名",  example = "1")
    private String en;

    /**
     * ip
     */
    @ApiModelProperty(value = "ip",  example = "192.168.0.1")
    private String ip;

    /**
     * 端口号
     */
    @ApiModelProperty(value = "端口号",  example = "8888")
    private String portNumber;

    /**
     * 备注
     */
    @ApiModelProperty(value = "ip",  example = "1")
    private String note;
    /**
     * 描述信息
     */
    @ApiModelProperty(value = "描述信息",  example = "1")
    private String description;
}
