package com.mt.wms.basic.params;

import com.mt.wms.core.base.BaseParam;
import com.mt.wms.core.validator.groups.UpdateGroup;
import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import lombok.Data;
import lombok.EqualsAndHashCode;
import lombok.experimental.Accessors;

import javax.validation.constraints.NotNull;

/**
 * @Author: liguanghao
 * @Date: 2021/9/27 14:54
 * @Version 1.0
 */
@Data
@EqualsAndHashCode(callSuper = false)
@Accessors(chain = true)
@ApiModel(value = "缓存区参数对象", description = "用于新增和更新缓存区信息")
public class WarehouseParam extends BaseParam {

    private static final long serialVersionUID = 1L;

    /**
     * 主键，自增
     */
    @ApiModelProperty(value = "主键，更新时需要填写",required = false, example = "1")
    @NotNull(message = "xxID不能为空", groups = {UpdateGroup.class})
    private Long id;

    /**
     * 编码
     */
    @ApiModelProperty(value = "编码",required = true, example = "1")
    @NotNull(message = "编码不能为空")
    private String  code;

    /**
     * 仓库名称
     */
    @ApiModelProperty(value = "仓库名称",required = true, example = "1")
    @NotNull(message = "仓库名称不能为空")
    private String warehouseName;

    /**
     * 规格
     */
    @ApiModelProperty(value = "规格",required = true, example = "1")
    private String spec;

    /**
     * 备注
     */
    @ApiModelProperty(value = "备注",required = true, example = "1")
    private String note;

    /**
     * 描述
     */
    @ApiModelProperty(value = "描述",required = true, example = "1")
    private String description;

    /**
     * 英文名称
     */
    @ApiModelProperty(value = "英文名称",required = false, example = "1")
    private String englishName;

    /**
     * 别名
     */
    @ApiModelProperty(value = "英文名称",required = false, example = "1")
    private String aliasName;

    /**
     * 库位数量
     */
    @ApiModelProperty(value = "英文名称",required = true, example = "1")
    private Integer number;

    /**
     * 状态		0初始化，1已占用
     */
    @ApiModelProperty(value = "状态",required = true, example = "1")
    private Integer status;
}
