package com.mt.wms.basic.vo;

import com.mt.wms.core.base.BaseVo;
import com.mt.wms.core.vo.PageVo;
import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import io.swagger.models.auth.In;
import lombok.Builder;
import lombok.Data;
import lombok.EqualsAndHashCode;
import lombok.experimental.Accessors;

import java.time.LocalDateTime;

/**
 * @Author: liguanghao
 * @Date: 2021/11/18 8:55
 * @Version 1.0
 */
@Data
@EqualsAndHashCode(callSuper = false)
@Accessors(chain = true)
@Builder
@ApiModel(value = "通讯日志视图对象", description = "用于查询通讯日志信息")
public class CommunicationVo extends BaseVo implements PageVo.ConvertVo {
    /**
     * 主键，自增
     */
    @ApiModelProperty(value = "主键，更新时需要填写", example = "1")
    private Long id;

    /**
     * 编码
     */
    @ApiModelProperty(value = "编码", example = "1")
    private String  code;

    /**
     * 日志名称
     */
    @ApiModelProperty(value = "日志名称", example = "1")
    private String logName;

    /**
     * 内容
     */
    @ApiModelProperty(value = "日志名称", example = "1")
    private String content;

    /**
     * 类型
     */
    @ApiModelProperty(value = "类型", example = "1")
    private Integer type;

    /**
     * 创建时间
     */
    @ApiModelProperty(value = "创建时间", example = "1")
    private LocalDateTime createTime;
}
