package com.mt.wms.basic.vo;

import com.mt.wms.core.base.BaseVo;
import com.mt.wms.core.vo.PageVo;
import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import lombok.Builder;
import lombok.Data;
import lombok.EqualsAndHashCode;
import lombok.experimental.Accessors;

/**
 * @Author: liguanghao
 * @Date: 2021/11/9 10:22
 * @Version 1.0
 */
@Data
@EqualsAndHashCode(callSuper = false)
@Accessors(chain = true)
@Builder
@ApiModel(value = "库位信息视图对象", description = "用于查询库位信息")
public class LocationInfoVo extends BaseVo implements PageVo.ConvertVo {
    /**
     * 主键，自增
     */
    @ApiModelProperty(value = "主键", required = true, example = "1")
    private Long id;

    /**
     * 编码
     */
    @ApiModelProperty(value = "编码",  example = "1")
    private String code;

    /**
     * 名称
     */
    @ApiModelProperty(value = "仓库名称",  example = "1")
    private String locationName;

    /**
     * 别名
     */
    @ApiModelProperty(value = "别名",  example = "1")
    private String locationNameAlias;

    /**
     * 状态
     */
    @ApiModelProperty(value = "状态:0空闲，1使用，2不可用",  example = "1")
    private Integer status;

    /**
     * 缓存区
     */
    @ApiModelProperty(value = "缓存区",  example = "1")
    private String warehouse;
    /**
     * 备注
     */
    @ApiModelProperty(value = "备注",  example = "1")
    private String note;

    /**
     * 描述信息
     */
    @ApiModelProperty(value = "描述信息",  example = "1")
    private String description;
}
