package com.mt.wms.basic.vo;

import com.mt.wms.core.base.BaseVo;
import com.mt.wms.core.vo.PageVo;
import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import lombok.Builder;
import lombok.Data;
import lombok.EqualsAndHashCode;
import lombok.experimental.Accessors;

/**
 * @Author: liguanghao
 * @Date: 2021/11/8 10:28
 * @Version 1.0
 */
@Data
@EqualsAndHashCode(callSuper = false)
@Accessors(chain = true)
@Builder
@ApiModel(value = "车辆视图对象", description = "用于查询车辆信息")
public class VehicleVo extends BaseVo implements PageVo.ConvertVo{
    /**
     * 主键，自增
     */
    @ApiModelProperty(value = "主键", required = true, example = "1")
    private Long id;

    /**
     * 编码
     */
    @ApiModelProperty(value = "编码",  example = "1")
    private String code;

    /**
     * 名称
     */
    @ApiModelProperty(value = "名称",  example = "1")
    private String vehicleName;

    /**
     * 别名
     */
    @ApiModelProperty(value = "缩写(别名)",  example = "1")
    private String vehicleAlias;

    /**
     * ip
     */
    @ApiModelProperty(value = "ip",  example = "192.168.0.1")
    private String ip;

    /**
     * 备注
     */
    @ApiModelProperty(value = "ip",  example = "1")
    private String note;
    /**
     * 描述信息
     */
    @ApiModelProperty(value = "描述信息",  example = "1")
    private String description;

    /**
     * 描述信息
     */
    @ApiModelProperty(value = "车辆状态：0-空闲，1-占用",  example = "1")
    private Integer status;
}
