package com.mt.wms.core.dal.entity;

import com.baomidou.mybatisplus.annotation.TableName;
import com.baomidou.mybatisplus.annotation.IdType;
import com.baomidou.mybatisplus.extension.activerecord.Model;
import com.baomidou.mybatisplus.annotation.Version;
import com.baomidou.mybatisplus.annotation.TableId;
import java.time.LocalDateTime;
import com.baomidou.mybatisplus.annotation.TableLogic;
import com.baomidou.mybatisplus.annotation.TableField;
import java.io.Serializable;
import lombok.Data;
import lombok.EqualsAndHashCode;
import lombok.experimental.Accessors;

/**
 * <p>
 * 当前任务明细
 * </p>
 *
 * @author mt
 * @since 2021-12-14
 */
@Data
@EqualsAndHashCode(callSuper = false)
@Accessors(chain = true)
@TableName("t_curr_task_det")
public class CurrTaskDet extends Model<CurrTaskDet> {

    private static final long serialVersionUID = 1L;

      @TableId(value = "id", type = IdType.AUTO)
    private Long id;

    /**
     * 删除标志，是否有效:1 可用 0不可用，2停止
     */
    @TableField("valid")
    @TableLogic
    private Integer valid;

    /**
     * 添加时间，每次修改记录要更新记录新增时间
     */
    @TableField("create_time")
    private LocalDateTime createTime;

    /**
     * 创建人id
     */
    @TableField("creator_id")
    private Integer creatorId;

    /**
     * 更新人id
     */
    @TableField("updater_id")
    private Integer updaterId;

    /**
     * 修改时间，更具修改时间来判断下次执行顺序，第一次修改时间和新增时间相同
     */
    @TableField("update_time")
    private LocalDateTime updateTime;

    /**
     * 版本号 默认为 1
     */
    @TableField("version")
    @Version
    private String version;

    /**
     * 状态：	0等待执行
     */
    @TableField("status")
    private Integer status;

    /**
     * 内部编码，系统自动生成
     */
    @TableField("inter_code")
    private String interCode;

    /**
     * 任务编码
     */
    @TableField("task_code")
    private String taskCode;

    /**
     * 当前任务id，关联当前任务表：t_curr_task
     */
    @TableField("curr_task_id")
    private Long currTaskId;

    /**
     * 订单号，
     */
    @TableField("order_no")
    private String orderNo;

    /**
     * 标识卡号，
     */
    @TableField("iden_card_num")
    private String idenCardNum;

    /**
     * 产品名称
     */
    @TableField("product_name")
    private String productName;

    /**
     * 材料牌号 
     */
    @TableField("material_des")
    private String materialDes;

    /**
     * 工艺要求 
     */
    @TableField("craft_ill")
    private String craftIll;

    /**
     * 单位
     */
    @TableField("unit")
    private String unit;

    /**
     * 重量，手动输入
     */
    @TableField("weight")
    private Float weight;

    /**
     * 数量，手动输入
     */
    @TableField("quantity")
    private Float quantity;


    public static final String ID = "id";

    public static final String VALID = "valid";

    public static final String CREATE_TIME = "create_time";

    public static final String CREATOR_ID = "creator_id";

    public static final String UPDATER_ID = "updater_id";

    public static final String UPDATE_TIME = "update_time";

    public static final String VERSION = "version";

    public static final String STATUS = "status";

    public static final String INTER_CODE = "inter_code";

    public static final String TASK_CODE = "task_code";

    public static final String CURR_TASK_ID = "curr_task_id";

    public static final String ORDER_NO = "order_no";

    public static final String IDEN_CARD_NUM = "iden_card_num";

    public static final String PRODUCT_NAME = "product_name";

    public static final String MATERIAL_DES = "material_des";

    public static final String CRAFT_ILL = "craft_ill";

    public static final String UNIT = "unit";

    public static final String WEIGHT = "weight";

    public static final String QUANTITY = "quantity";

    @Override
    protected Serializable pkVal() {
        return this.id;
    }

}
