package com.mt.wms.core.dal.entity;

import com.baomidou.mybatisplus.annotation.TableName;
import com.baomidou.mybatisplus.annotation.IdType;
import com.baomidou.mybatisplus.extension.activerecord.Model;
import com.baomidou.mybatisplus.annotation.Version;
import com.baomidou.mybatisplus.annotation.TableId;
import java.time.LocalDateTime;
import com.baomidou.mybatisplus.annotation.TableLogic;
import com.baomidou.mybatisplus.annotation.TableField;
import java.io.Serializable;
import lombok.Data;
import lombok.EqualsAndHashCode;
import lombok.experimental.Accessors;

/**
 * <p>
 * 缓存区存储情况
 * </p>
 *
 * @author mt
 * @since 2021-12-14
 */
@Data
@EqualsAndHashCode(callSuper = false)
@Accessors(chain = true)
@TableName("t_in_stock_info")
public class InStockInfo extends Model<InStockInfo> {

    private static final long serialVersionUID = 1L;

      @TableId(value = "id", type = IdType.AUTO)
    private Long id;

    /**
     * 删除标志，是否有效:1 可用 0不可用，2停止
     */
    @TableField("valid")
    @TableLogic
    private Integer valid;

    /**
     * 添加时间，入库时间
     */
    @TableField("create_time")
    private LocalDateTime createTime;

    /**
     * 创建人id
     */
    @TableField("creator_id")
    private Integer creatorId;

    /**
     * 更新人id
     */
    @TableField("updater_id")
    private Integer updaterId;

    /**
     * 修改时间，更具修改时间来判断下次执行顺序，第一次修改时间和新增时间相同
     */
    @TableField("update_time")
    private LocalDateTime updateTime;

    /**
     * 版本号 默认为 1
     */
    @TableField("version")
    @Version
    private String version;

    /**
     * 状态：	0未开始执行，1正在执行，2执行完成
     */
    @TableField("status")
    private Integer status;

    /**
     * 内部编码，系统自动生成
     */
    @TableField("inter_code")
    private String interCode;

    /**
     * 任务编码
     */
    @TableField("task_code")
    private String taskCode;

    /**
     * 任务id，关联当前任务表：currTask
     */
    @TableField("task_id")
    private Long taskId;

    /**
     * 工业炉id ，if(status == 0){从工业炉出来等待库存} else if(status == 1){到目标工业炉前缓存到库位}关联设备工业炉表：t_kiln_info
     */
    @TableField("kiln_id")
    private Long kilnId;

    /**
     * 工业炉名称
     */
    @TableField("kiln_name")
    private String kilnName;

    /**
     * 库位id，关联库位表：t_location
     */
    @TableField("location_id")
    private Long locationId;

    /**
     * 库位名称
     */
    @TableField("location_name")
    private String locationName;

    /**
     * 托盘编码
     */
    @TableField("pallet_code")
    private String palletCode;

    /**
     * 类型：	0等待出库，1到工业炉前缓存，2插单任务缓存
     */
    @TableField("type")
    private Integer type;

    /**
     * 进入缓存区的时间，插单任务按倒叙执行，正常任务按顺序执行
     */
    @TableField("in_time")
    private LocalDateTime inTime;


    public static final String ID = "id";

    public static final String VALID = "valid";

    public static final String CREATE_TIME = "create_time";

    public static final String CREATOR_ID = "creator_id";

    public static final String UPDATER_ID = "updater_id";

    public static final String UPDATE_TIME = "update_time";

    public static final String VERSION = "version";

    public static final String STATUS = "status";

    public static final String INTER_CODE = "inter_code";

    public static final String TASK_CODE = "task_code";

    public static final String TASK_ID = "task_id";

    public static final String KILN_ID = "kiln_id";

    public static final String KILN_NAME = "kiln_name";

    public static final String LOCATION_ID = "location_id";

    public static final String LOCATION_NAME = "location_name";

    public static final String PALLET_CODE = "pallet_code";

    public static final String TYPE = "type";

    public static final String IN_TIME = "in_time";

    @Override
    protected Serializable pkVal() {
        return this.id;
    }

}
