package com.mt.wms.core.dal.entity;

import com.baomidou.mybatisplus.annotation.TableName;
import com.baomidou.mybatisplus.annotation.IdType;
import com.baomidou.mybatisplus.extension.activerecord.Model;
import com.baomidou.mybatisplus.annotation.Version;
import com.baomidou.mybatisplus.annotation.TableId;
import java.time.LocalDateTime;
import com.baomidou.mybatisplus.annotation.TableField;
import java.io.Serializable;
import lombok.Data;
import lombok.EqualsAndHashCode;
import lombok.experimental.Accessors;

/**
 * <p>
 * 工业炉电能参数值
 * </p>
 *
 * @author mt
 * @since 2022-03-01
 */
@Data
@EqualsAndHashCode(callSuper = false)
@Accessors(chain = true)
@TableName("t_par_ele_value")
public class ParEleValue extends Model<ParEleValue> {

    private static final long serialVersionUID = 1L;

      @TableId(value = "id", type = IdType.AUTO)
    private Long id;

    /**
     * 添加时间
     */
    @TableField("create_time")
    private LocalDateTime createTime;

    /**
     * 内部编码，系统自动生成
     */
    @TableField("inter_code")
    private String interCode;

    /**
     * 状态	0初始化，1损坏
     */
    @TableField("status")
    private Integer status;

    /**
     * 工业炉id，关联设备工业炉表：t_kiln_info
     */
    @TableField("kiln_id")
    private Long kilnId;

    /**
     * 任务id
     */
    @TableField("task_id")
    private Long taskId;

    /**
     * 参数id，关联参数表：t_par_info
     */
    @TableField("par_id")
    private Integer parId;

    /**
     * A相电压
     */
    @TableField("a_voltagev_value")
    private Float aVoltagevValue;

    /**
     * B相电压
     */
    @TableField("b_voltagev_value")
    private Float bVoltagevValue;

    /**
     * C相电压
     */
    @TableField("c_voltagev_value")
    private Float cVoltagevValue;

    /**
     * A相电流
     */
    @TableField("a_current_value")
    private Float aCurrentValue;

    /**
     * B相电流
     */
    @TableField("b_current_value")
    private Float bCurrentValue;

    /**
     * C相电流
     */
    @TableField("c_current_value")
    private Float cCurrentValue;

    /**
     * 总电量，单位KW
     */
    @TableField("total_bat")
    private Float totalBat;

    /**
     * 时间段类型。0：半小时，1：天，2:月
     */
    @TableField("date_type")
    private Integer dateType;

    /**
     * 扩展字段2
     */
    @TableField("add_b")
    private Float addB;

    /**
     * 扩展字段3
     */
    @TableField("add_c")
    private Float addC;

    /**
     * 扩展字段4
     */
    @TableField("orther_a")
    private String ortherA;

    /**
     * 扩展字段5
     */
    @TableField("orther_b")
    private String ortherB;

    /**
     * 扩展字段6
     */
    @TableField("orther_c")
    private String ortherC;


    public static final String ID = "id";

    public static final String CREATE_TIME = "create_time";

    public static final String INTER_CODE = "inter_code";

    public static final String STATUS = "status";

    public static final String KILN_ID = "kiln_id";

    public static final String TASK_ID = "task_id";

    public static final String PAR_ID = "par_id";

    public static final String A_VOLTAGEV_VALUE = "a_voltagev_value";

    public static final String B_VOLTAGEV_VALUE = "b_voltagev_value";

    public static final String C_VOLTAGEV_VALUE = "c_voltagev_value";

    public static final String A_CURRENT_VALUE = "a_current_value";

    public static final String B_CURRENT_VALUE = "b_current_value";

    public static final String C_CURRENT_VALUE = "c_current_value";

    public static final String TOTAL_BAT = "total_bat";

    public static final String DATE_TYPE = "date_type";

    public static final String ADD_B = "add_b";

    public static final String ADD_C = "add_c";

    public static final String ORTHER_A = "orther_a";

    public static final String ORTHER_B = "orther_b";

    public static final String ORTHER_C = "orther_c";

    @Override
    protected Serializable pkVal() {
        return this.id;
    }

}
