package com.mt.wms.core.dal.entity;

import com.baomidou.mybatisplus.annotation.TableName;
import com.baomidou.mybatisplus.annotation.IdType;
import com.baomidou.mybatisplus.extension.activerecord.Model;
import com.baomidou.mybatisplus.annotation.Version;
import com.baomidou.mybatisplus.annotation.TableId;
import java.time.LocalDateTime;
import com.baomidou.mybatisplus.annotation.TableLogic;
import com.baomidou.mybatisplus.annotation.TableField;
import java.io.Serializable;
import lombok.Data;
import lombok.EqualsAndHashCode;
import lombok.experimental.Accessors;

/**
 * <p>
 * 参数表
 * </p>
 *
 * @author mt
 * @since 2021-11-18
 */
@Data
@EqualsAndHashCode(callSuper = false)
@Accessors(chain = true)
@TableName("t_par_info")
public class ParInfo extends Model<ParInfo> {

    private static final long serialVersionUID = 1L;

      @TableId(value = "id", type = IdType.AUTO)
    private Long id;

    /**
     * 删除标志，是否有效:1 可用 0不可用
     */
    @TableField("valid")
    @TableLogic
    private Integer valid;

    /**
     * 添加时间
     */
    @TableField("create_time")
    private LocalDateTime createTime;

    /**
     * 创建人id
     */
    @TableField("creator_id")
    private Integer creatorId;

    /**
     * 更新人id
     */
    @TableField("updater_id")
    private Integer updaterId;

    /**
     * 修改时间
     */
    @TableField("update_time")
    private LocalDateTime updateTime;

    /**
     * 版本号 默认为 1
     */
    @TableField("version")
    @Version
    private String version;

    /**
     * 状态	0初始化，1损坏
     */
    @TableField("status")
    private Integer status;

    /**
     * 内部编码，系统自动生成
     */
    @TableField("inter_code")
    private String interCode;

    /**
     * 编码
     */
    @TableField("code")
    private String code;

    /**
     * 参数类型，0 表示电能，1表示用气，3温度，4转速  依次类推
     */
    @TableField("type")
    private Integer type;

    /**
     * 参数分类，eg:if (type ==0 && class_a== 0) {class_a== 0表示A向电压，class_a== 1，表示B向电压，class_a== 2，表示C向电压,依次类推} 
     */
    @TableField("class_a")
    private Integer classA;

    /**
     * 参数分类，eg:if (type ==0 && class_b== 0) {class_b== 0表示A向电流，class_b== 1，表示B向电流，class_b== 2，表示C向电流,依次类推} 
     */
    @TableField("class_b")
    private Integer classB;

    /**
     * 参数名称
     */
    @TableField("par_name")
    private String parName;

    /**
     * 单位，数据字典获取
     */
    @TableField("unit")
    private String unit;


    public static final String ID = "id";

    public static final String VALID = "valid";

    public static final String CREATE_TIME = "create_time";

    public static final String CREATOR_ID = "creator_id";

    public static final String UPDATER_ID = "updater_id";

    public static final String UPDATE_TIME = "update_time";

    public static final String VERSION = "version";

    public static final String STATUS = "status";

    public static final String INTER_CODE = "inter_code";

    public static final String CODE = "code";

    public static final String TYPE = "type";

    public static final String CLASS_A = "class_a";

    public static final String CLASS_B = "class_b";

    public static final String PAR_NAME = "par_name";

    public static final String UNIT = "unit";

    @Override
    protected Serializable pkVal() {
        return this.id;
    }

}
