/*
 * Copyright (c) 2018.
 * http://www.ulabcare.com
 */

package com.mt.wms.core.dto;

import com.mt.wms.core.base.BaseDto;
import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import lombok.Builder;
import lombok.Data;
import lombok.EqualsAndHashCode;

/**
 * 权限类
 *
 * @author jiff
 * @date 2018/11/1
 * @since 1.0
 */
@Builder
@Data
@EqualsAndHashCode(callSuper = false)
@ApiModel(value = "权限类", description = "用于统一用户服务对接口鉴权")
public class Permission extends BaseDto {
    /**
     * 请求地址，可以用于前端ajax调用，后端用于做权限控制
     */
    @ApiModelProperty(value = "url", required = true, example = "/platform-upms/resource/add")
    private String url;

    /**
     * 请求类型：GET, HEAD, POST, PUT, PATCH, DELETE, OPTIONS, TRACE
     */
    @ApiModelProperty(value = "请求类型：GET, HEAD, POST, PUT, PATCH, DELETE, OPTIONS, TRACE", required = true, example = "post")
    private String method;


}
