/*
 * Copyright (c) 2018.
 * http://www.ulabcare.com
 */

package com.mt.wms.core.enums;

import com.mt.wms.core.base.IEnum;

/**
 * 菜单分类枚举:1、pc，2、app，3、wechat，4、miniapp
 * <br>角色分类共用该枚举类型
 *
 * @author jiff
 * @date 2018/11/22
 * @since 1.0
 */
public enum MenuCategoryEnum implements IEnum<Integer> {
    /**
     * pc
     */
    PC(1, "pc"),
    /**
     * app
     */
    APP(2, "app"),
    /**
     * 微信公众号
     */
    WECHAT(3, "微信公众号"),
    /**
     * 微信小程序
     */
    MINIAPP(4, "微信小程序");


    private final Integer value;
    private final String label;
    private final String remark;

    MenuCategoryEnum(final Integer value, final String label) {
        this(value, label, null);
    }

    MenuCategoryEnum(final Integer value, final String label, final String remark) {
        this.value = value;
        this.label = label;
        this.remark = remark;
    }

    /**
     * @return 数据值
     */
    @Override
    public Integer getValue() {
        return value;
    }

    /**
     * @return 标签名
     */
    @Override
    public String getLabel() {
        return label;
    }

    /**
     * @return 备注
     */
    @Override
    public String getRemark() {
        return remark;
    }
}
