/*
 * Copyright (c) 2018.
 * http://www.ulabcare.com
 */

package com.mt.wms.core.params;

import com.mt.wms.core.base.BaseParam;
import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import lombok.Data;
import lombok.EqualsAndHashCode;
import lombok.experimental.Accessors;

import javax.validation.constraints.NotNull;
import javax.validation.constraints.Size;
import java.util.List;


/**
 * 主键列表请求参数对象
 *
 * @author jiff
 * @date 2018/11/9
 * @since 1.0
 */
@Data
@EqualsAndHashCode(callSuper = false)
@Accessors(chain = true)
@ApiModel("主键列表参数对象")
public class IdListParam extends BaseParam {
    @ApiModelProperty(value = "主键列表", required = true, example = "[1]", notes = "根据实际接口传递不同对象的主键列表")
    @NotNull(message = "主键列表不能为空")
    @Size(message = "主键列表不能为空", min = 1)
    private List<Long> ids;

}
