package com.mt.wms.empty.controller;

import com.mt.wms.core.base.BaseController;
import com.mt.wms.core.constants.CommonConstant;
import com.mt.wms.core.validator.groups.PageGroup;
import com.mt.wms.core.vo.PageVo;
import com.mt.wms.core.vo.R;
import com.mt.wms.empty.params.AlarmInfoQueryParam;
import com.mt.wms.empty.service.AlarmInfoService;
import com.mt.wms.empty.vo.AlarmInfoVo;
import io.swagger.annotations.Api;
import io.swagger.annotations.ApiOperation;
import lombok.extern.slf4j.Slf4j;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.validation.annotation.Validated;
import org.springframework.web.bind.annotation.PostMapping;
import org.springframework.web.bind.annotation.RequestBody;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RestController;

import javax.annotation.Resource;
import javax.validation.groups.Default;
import java.util.List;

/**
 * @Author: liguanghao
 * @Date: 2021/12/16 19:22
 * @Version 1.0
 */
@RestController
@RequestMapping(CommonConstant.API_MODULE_BASE + "alarmInfo")
@Slf4j
@Api(value = "报警信息相关接口", tags = "报警信息相关接口", hidden = false)
public class AlarmInfoController extends BaseController {


    @Autowired
    private AlarmInfoService alarmInfoService;

    @PostMapping(value = "page")
    @ApiOperation(value = "获取分页报警基础信息")
    private R<PageVo<AlarmInfoVo>> page(@Validated({PageGroup.class, Default.class}) @RequestBody AlarmInfoQueryParam alarmInfoQueryParam) {
        return alarmInfoService.page(alarmInfoQueryParam);
    }
}
