package com.mt.wms.empty.controller;

import com.mt.wms.core.base.BaseController;
import com.mt.wms.core.constants.CommonConstant;
import com.mt.wms.core.vo.PageVo;
import com.mt.wms.core.vo.R;
import com.mt.wms.empty.params.CurrTaskDetQueryParam;
import com.mt.wms.empty.service.CurrTaskDetService;
import com.mt.wms.empty.vo.CurrTaskDetVo;
import io.swagger.annotations.Api;
import io.swagger.annotations.ApiOperation;
import lombok.extern.slf4j.Slf4j;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.validation.annotation.Validated;
import org.springframework.web.bind.annotation.PostMapping;
import org.springframework.web.bind.annotation.RequestBody;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RestController;

/**
 * @author xcc
 * @date 2021年11月8日
 * @since 1.0
 */
@RestController
@RequestMapping(CommonConstant.API_MODULE_BASE + "currTaskDet")
@Slf4j
@Api(value = "任务详情管理", tags = "当前任务详情管理", hidden = false)
public class CurrTaskDetController extends BaseController {
    @Autowired
    CurrTaskDetService currTaskDetService;

    @PostMapping(value = "getTaskDet")
    @ApiOperation(value = "当前执行任务-查看详情")
    public R<PageVo<CurrTaskDetVo>> getTaskDetailsPage(@Validated@RequestBody CurrTaskDetQueryParam currTaskId){
       return currTaskDetService.getTaskDetailsPage(currTaskId);
    }
}
