package com.mt.wms.empty.params;

import com.mt.wms.core.base.BaseParam;
import com.mt.wms.core.params.BasePageParam;
import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import lombok.Data;
import lombok.EqualsAndHashCode;
import lombok.experimental.Accessors;

/**
 * @author xcc
 * @date 2021年11月9日
 * @since 1.0
 */
@Data
@EqualsAndHashCode(callSuper = false)
@Accessors(chain = true)
@ApiModel(value = "订单详细信息", description = "新建一个订单的详细信息")
public class TaskCreateDetParam extends BaseParam {

    private static final long serialVersionUID = 1L;
    

    /**
     * 标识卡号
     */
   @ApiModelProperty(value = "标识卡号", required = true)
    private String idenCardNum;

    /**
     * 订单号，APMS系统获取
     */
   @ApiModelProperty(value = "订单号", required = false)
    private String orderNo;

    /**
     * 客户名称、
     */
    @ApiModelProperty(value = "客户名称")
    private String customerName;

    /**
     * 产品名称、
     */
    @ApiModelProperty(value = "产品名称")
    private String productName;

    /**
     * 材料牌号 APMS系统获取
     */
    @ApiModelProperty(value = "材料牌号")
    private String materialDes;

    /**
     * 单位
     */
    @ApiModelProperty(value = "单位")
    private String unit;

    /**
     * 重量
     */
    @ApiModelProperty(value = "重量",required = true)
    private Float weight;

    /**
     * 数量
     */
    @ApiModelProperty(value = "数量",required = true)
    private Float quantity;

}
