package com.mt.wms.empty.service.impl;

import com.baomidou.mybatisplus.core.conditions.query.QueryWrapper;
import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
import com.mt.wms.core.base.BaseService;
import com.mt.wms.core.dal.entity.AlarmInfo;
import com.mt.wms.core.dal.service.AlarmInfoServiceBiz;
import com.mt.wms.core.vo.PageVo;
import com.mt.wms.core.vo.R;
import com.mt.wms.empty.params.AlarmInfoQueryParam;
import com.mt.wms.empty.service.AlarmInfoService;
import com.mt.wms.empty.vo.AlarmInfoVo;
import org.apache.commons.lang.StringUtils;
import org.springframework.stereotype.Service;
import org.springframework.transaction.annotation.Transactional;

import javax.annotation.Resource;

/**
 * @Author: liguanghao
 * @Date: 2021/12/16 19:21
 * @Version 1.0
 */
@Service
@Transactional
public class AlarmInfoServiceImpl extends BaseService implements AlarmInfoService {

    @Resource
    private AlarmInfoServiceBiz alarmInfoServiceBiz;
    @Override
    public R<PageVo<AlarmInfoVo>> page(AlarmInfoQueryParam alarmInfoQueryParam) {

        QueryWrapper<AlarmInfo> wrapper = new QueryWrapper<>();
        wrapper.between(alarmInfoQueryParam.getStartTime() != null, AlarmInfo.CREATE_TIME, alarmInfoQueryParam.getStartTime(), alarmInfoQueryParam.getEndTime())
                .eq(AlarmInfo.TYPE, alarmInfoQueryParam.getType())
                .eq(alarmInfoQueryParam.getEquipmentId() != null, AlarmInfo.EQUIPMENT_ID, alarmInfoQueryParam.getEquipmentId())
                .orderByDesc(AlarmInfo.CREATE_TIME);
        Page<AlarmInfo> page = alarmInfoServiceBiz.page(new Page<>(alarmInfoQueryParam.getCurrent(), alarmInfoQueryParam.getSize()), wrapper);
        return successful(new PageVo<>(page, AlarmInfoVo.class));
    }
}

