package com.mt.wms.empty.service.impl;

import com.baomidou.mybatisplus.core.conditions.query.QueryWrapper;
import com.mt.wms.core.base.BaseService;
import com.mt.wms.core.dal.entity.InStockInfo;
import com.mt.wms.core.dal.entity.InStockInfoHis;
import com.mt.wms.core.dal.entity.RunTask;
import com.mt.wms.core.dal.entity.VehicleInfo;
import com.mt.wms.core.dal.service.InStockInfoHisServiceBiz;
import com.mt.wms.core.dal.service.InStockInfoServiceBiz;
import com.mt.wms.core.dal.service.RunTaskServiceBiz;
import com.mt.wms.core.dal.service.VehicleInfoServiceBiz;
import com.mt.wms.core.dal.service.impl.InStockInfoHisServiceBizImpl;
import com.mt.wms.core.vo.R;
import com.mt.wms.empty.params.OutStockParam;
import com.mt.wms.empty.service.OutStockService;
import com.mt.wms.empty.task.AsynRunTaskService;
import com.mt.wms.empty.task.RunTaskUtils;
import org.springframework.beans.BeanUtils;
import org.springframework.stereotype.Service;
import org.springframework.transaction.annotation.Transactional;

import javax.annotation.Resource;
import javax.validation.constraints.NotNull;
import java.io.IOException;
import java.time.LocalDateTime;
import java.util.List;

/**
 * @Author: liguanghao
 * @Date: 2021/12/17 8:52
 * @Version 1.0
 */
@Service
@Transactional
public class OutStockServiceImpl extends BaseService implements OutStockService {

    @Resource
    private VehicleInfoServiceBiz vehicleInfoServiceBiz;
    @Resource
    private AsynRunTaskService asynRunTaskService;
    @Resource
    private InStockInfoServiceBiz inStockInfoServiceBiz;
    @Resource
    private RunTaskServiceBiz runTaskServiceBiz;
    @Resource
    private RunTaskUtils runTaskUtils;


    @Override
    public R outTask(OutStockParam outStockParam) throws IOException {
        // 2021/12/17 出库
        Long locationId = outStockParam.getLocaltionId();
        //提升台
        String code = outStockParam.getCode();
        return runTaskUtils.runTaskForOut(locationId,code);
    }
}
