package com.mt.wms.empty.service.impl;

import com.baomidou.mybatisplus.core.conditions.query.QueryWrapper;
import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
import com.mt.wms.core.base.BaseService;
import com.mt.wms.core.dal.entity.TaskHis;
import com.mt.wms.core.dal.service.TaskHisServiceBiz;
import com.mt.wms.core.params.IdParam;
import com.mt.wms.core.vo.IdVo;
import com.mt.wms.core.vo.PageVo;
import com.mt.wms.core.vo.R;
import com.mt.wms.empty.params.TaskHisQueryParam;
import com.mt.wms.empty.service.TaskHisService;
import com.mt.wms.empty.vo.CurrTaskVo;
import com.mt.wms.empty.vo.TaskHisQueryVo;
import org.apache.commons.lang.StringUtils;
import org.springframework.beans.BeanUtils;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;
import org.springframework.transaction.annotation.Transactional;

import java.util.Objects;

/**
 * 服务实现类
 *
 * @author xcc
 * @date 2021年11月8日
 * @since 1.0
 */
@Service
@Transactional
public class TaskHisServiceImpl extends BaseService implements TaskHisService {

    @Autowired
    TaskHisServiceBiz taskHisService;


    @Override
    public R<IdVo> save(TaskHis taskHis) {
        taskHisService.save(taskHis);
        return successful(IdVo.builder().id(taskHis.getId()).build());
    }

    @Override
    public CurrTaskVo getById(IdParam id) {
        //TaskHis byId = taskHisService.getById(id.getId());
        TaskHis byId = taskHisService.getOne(new QueryWrapper<TaskHis>().eq(TaskHis.TASK_ID, id.getId()));
        CurrTaskVo build = CurrTaskVo.builder().build();
        BeanUtils.copyProperties(byId, build);
        return build;
    }

    @Override
    public R<PageVo<TaskHisQueryVo>> taskHisPage(TaskHisQueryParam param) {
        QueryWrapper<TaskHis> queryWrapper = new QueryWrapper<>();
        queryWrapper.eq(StringUtils.isNotBlank(param.getSheetNo()),TaskHis.SHEET_NO,param.getSheetNo());
        queryWrapper.between(Objects.nonNull(param.getStartTime()) && Objects.nonNull(param.getEndTime()), TaskHis.CREATE_TIME, param.getStartTime(), param.getEndTime())
                .eq(TaskHis.VALID, 1).orderByDesc(TaskHis.CREATE_TIME);
        Page<TaskHis> page = taskHisService.page(new Page<>(param.getCurrent(), param.getSize()), queryWrapper);
        return successful(new PageVo<>(page, TaskHisQueryVo.class));
    }
}
