package com.mt.wms.empty.vo;

import com.mt.wms.core.base.BaseVo;
import com.mt.wms.core.vo.PageVo;
import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import lombok.Builder;
import lombok.Data;
import lombok.EqualsAndHashCode;
import lombok.experimental.Accessors;

import java.time.LocalDateTime;

/**
 *
 * @author xcc
 * @date 2021年11月8日
 * @since 1.0
 */
@Data
@EqualsAndHashCode(callSuper = false)
@Accessors(chain = true)
@Builder
@ApiModel(value = "任务详细信息", description = "用于返回任务详细信息")
public class CurrTaskDetVo extends BaseVo implements PageVo.ConvertVo {
    @ApiModelProperty(value = "id")
    private Long id;
    /**
     * 修改时间，更具修改时间来判断下次执行顺序，第一次修改时间和新增时间相同
     */
    @ApiModelProperty("修改时间")
    private LocalDateTime updateTime;

    /**
     * 状态：	0等待执行
     */
    @ApiModelProperty("状态")
    private Integer status;
    /**
     * 任务编码
     */
    @ApiModelProperty("任务编码")
    private String taskCode;
    @ApiModelProperty("客户名")
    private String customer;
    @ApiModelProperty("订单名")
    private String orderNo;
    /**
     * 当前任务id，关联当前任务表：t_curr_task
     */
    @ApiModelProperty("当前任务id")
    private Long currTaskId;
    /**
     * 重量，手动输入
     */
    @ApiModelProperty("重量")
    private Float weight;

    @ApiModelProperty("标识卡号")
    private String idenCardNum;

    /**
     * 产品名称
     */
    @ApiModelProperty("产品名称")
    private String productName;

    /**
     * 材料牌号
     */
    @ApiModelProperty("材料牌号")
    private String materialDes;

    /**
     * 产品型号
     */
    @ApiModelProperty("产品型号")
    private String productModel;

    /**
     * 工艺要求
     */
    @ApiModelProperty("工艺要求")
    private String craftIll;

    /**
     * 单位
     */
    @ApiModelProperty("单位")
    private String unit;

    /**
     * 数量，手动输入
     */
    @ApiModelProperty("数量")
    private Float quantity;
}
