package com.mt.wms.empty.vo;

import com.baomidou.mybatisplus.annotation.TableField;
import com.mt.wms.core.base.BaseVo;
import com.mt.wms.core.vo.PageVo;
import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import lombok.Builder;
import lombok.Data;
import lombok.EqualsAndHashCode;
import lombok.experimental.Accessors;

import java.time.LocalDateTime;

/**
 *
 * @author xcc
 * @date 2021年11月8日
 * @since 1.0
 */
@Data
@EqualsAndHashCode(callSuper = false)
@Accessors(chain = true)
@Builder
@ApiModel(value = "当前任务信息", description = "当前任务信息")
public class CurrTaskVo extends BaseVo implements PageVo.ConvertVo {
    @ApiModelProperty(value = "id")
    private Long id;

    /**
     * 删除标志，是否有效:1 可用 0不可用，2停止
     */
    @ApiModelProperty("删除标志")
    private Integer valid;


    /**
     * 状态：	0等待执行，1执行中，2执行完成，3追加后完成（追加后就按完成来算）
     */
    @ApiModelProperty("状态")
    private Integer status;

    /**
     * 内部编码，系统自动生成
     */
    @ApiModelProperty("内部编码")
    private String interCode;

    /**
     * 任务编码, 查看任务编码规则
     */
    @ApiModelProperty("任务编码")
    private String taskCode;

    /**
     * 任务来源, 暂时只有人工
     */
    @ApiModelProperty("任务来源")
    private String taskSource;

    /**
     * 任务类型：0:入库到工业炉，1:入库到缓存区，2出库到	工业炉到缓存区，3缓存区出库
     */
    @ApiModelProperty("任务类型")
    private Integer taskType;

    /**
     * 加工类型：0 初始加工，1 复加工 ，2 追加加工
     */
    @ApiModelProperty("任务类型")
    private Integer processType;

    /**
     * 托盘编码
     */
    @ApiModelProperty("托盘编码")
    private String palletCode;

    /**
     * 发起任务时间
     */
    @ApiModelProperty("发起时间")
    private LocalDateTime createTime;

    /**
     * 缓存前开始时间，车辆开始执行
     */
    @ApiModelProperty("任务开始")
    private LocalDateTime beginTime;

    /**
     * 完成当前任务时间（可能是到缓存区，有可能直接到工业炉），车辆放完货物到缓存区收到的时间
     */
    @ApiModelProperty("任务结束")
    private LocalDateTime endTime;

    /**
     * 开始位置
     */
    @ApiModelProperty("开始位置")
    private String startPosition;

    /**
     * 目标位置指的是工业炉的位置
     */
    @ApiModelProperty("工业炉位置")
    private String targetPosition;

    /**
     * 目标工业炉id
     */
    @ApiModelProperty("目标工业炉id")
    private Long kilnId;

    /**
     * 车辆id，关联车辆表：t_vehicle_info
     */
    @ApiModelProperty("车辆id")
    private Long vehicleId;
    /**
     * 库位id，关联库位表：t_location
     */
    @ApiModelProperty("location_id")
    private Integer locationId;
    /**
     * 库位名称
     */
    @ApiModelProperty("location_name")
    private String locationName;
    /**
     * 是否自动执行：	0手动，1自动，如果是自动任务这里要监控进出和到缓存区的调度任务
     */
    @TableField("is_auto")
    private Integer isAuto;

    /**
     * 任务流程ID，关联流程表：t_auto_exe_task
     */
    @TableField("auto_exe_task_id")
    private Long autoExeTaskId;
    /**
     * currid
     */
    @TableField("auto_exe_task_id")
    private Long taskId;
}
