/*
 * Copyright (c) 2018.
 * http://www.ulabcare.com
 */

package com.mt.wms.gateway.feign.fallback;

import com.mt.wms.core.dto.LoginUser;
import com.mt.wms.core.vo.R;
import com.mt.wms.gateway.feign.PassportService;
import com.mt.wms.passport.controller.PassportController;
import lombok.extern.slf4j.Slf4j;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

/**
 * 统一用户服务失败回调实现
 *
 * @author jiff
 * @date 2018/11/1
 * @since 1.0
 */
@Service
@Slf4j
public class PassportServiceFallback implements PassportService {
    @Autowired
    PassportController passportController;

    @Override
    public R<LoginUser> authorization(String url, String method) {
        return passportController.authorization(url, method);
    }
}
