/*
 * Copyright (c) 2018.
 * http://www.ulabcare.com
 */

package com.mt.wms.upms.params;

import com.mt.wms.core.params.BasePageParam;
import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import lombok.Builder;
import lombok.Data;
import lombok.EqualsAndHashCode;
import lombok.experimental.Accessors;

/**
 * <p>
 * 系统组织
 * </p>
 *
 * @author jiff
 * @date 2018/11/22
 * @since 1.0
 */
@EqualsAndHashCode(callSuper = false)
@Accessors(chain = true)
@Data
@Builder
@ApiModel(value = "系统组织查询参数", description = "用于查询组织信息")
public class SysOrgQueryParam extends BasePageParam {

    /**
     * 父组织ID
     */
    @ApiModelProperty(value = "父组织ID, 没有指定父ID时则查询当前用户所能管理的所有组织，包括用户所在组织及所有子组织", example = "0")
    private Long parentId;
    /**
     * 名称
     */
    @ApiModelProperty(value = "名称", required = false, example = "销售部", position = 1)
    private String name;

}
