package com.mt.wms.upms.vo;

import com.mt.wms.core.base.ITree;
import com.mt.wms.core.vo.CommonVo;
import com.mt.wms.core.vo.PageVo;
import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import lombok.Builder;
import lombok.Data;
import lombok.EqualsAndHashCode;
import lombok.experimental.Accessors;

import java.util.List;

/**
 * @Description: 返回岗位对象
 * @Param:
 * @return:
 * @Author: tqq
 * @Date: 2019/11/11 16:06
 */
@Data
@EqualsAndHashCode(callSuper = false)
@Accessors(chain = true)
@Builder
@ApiModel(value = "岗位对象 ", description = "用于返回岗位对象")
public class SysPostVo extends CommonVo implements PageVo.ConvertVo, ITree<SysPostVo> {

    private static final long serialVersionUID = 1L;
    @ApiModelProperty(value = "主键")
    private Long id;
    @ApiModelProperty(value = "父岗位id")
    private Long parentId;
    @ApiModelProperty(value = "岗位编码")
    private String code;
    @ApiModelProperty(value = "岗位名称")
    private String name;
    @ApiModelProperty("备注")
    private String remark;

    @ApiModelProperty(value = "子列表，用于获取岗位树时才有数据", required = false)
    private List<SysPostVo> children;

}
